package br.ufpr.inf.rp09.testdefinitions;

import org.apache.jmeter.control.LoopController;
import org.apache.jmeter.protocol.http.sampler.HTTPSampler;
import org.apache.jmeter.protocol.jdbc.sampler.JDBCSampler;
import org.apache.jmeter.testelement.AbstractTestElement;
import org.apache.jmeter.threads.ThreadGroup;
import org.apache.jorphan.collections.HashTree;

import br.ufpr.inf.rp09.testresults.TestResultCollector;

/**
 * Implementa o plano de teste a ser executado por um cliente de teste JMeter
 * 
 * @author Rodrigo Piassetta / GRR20094994
 *
 */
public final class ModastTestPlan extends HashTree {

	private static final long serialVersionUID = 5441352222408389956L;

	private ThreadGroup threadGroup; //controla o numero de threads executadas pelo plano de teste
	private LoopController loopController; //controla o numero de iteracoes executadas por cada thread
	private AbstractTestElement sampler; //executa as amostras de testes/requisicoes
	private TestResultCollector testResultCollector; //recebe os resultados das amostras

	public ModastTestPlan() {
		super();
	}
	
	public ModastTestPlan(HashTree hashTree) {
		super(hashTree);
	}

	public TestResultCollector getTestResultCollector() {
		return this.testResultCollector;
	}

	public void setTestResultCollector(TestResultCollector dBTestResultCollector) {
		this.testResultCollector = dBTestResultCollector;
	}

	public void setThreadGroup(ThreadGroup threadGroup) {
		this.threadGroup = threadGroup;
	}

	public void setLoopController(LoopController loopController) {
		this.loopController = loopController;
	}
	
	public void setSampler(JDBCSampler jdbcSampler) {
		this.sampler = jdbcSampler;		
	}

	public void setSampler(HTTPSampler httpSampler) {
		this.sampler = httpSampler;		
	}
	
	public void setNumThreads(int numThreads) {
		this.threadGroup.setNumThreads(numThreads);		
	}

	public int getNumThreads() {
		return this.threadGroup.getNumThreads();	
	}

	public void setNumLoops(int numLoops) {
		this.loopController.setLoops(numLoops);
	}

	public int getNumLoops() {
		return this.loopController.getLoops();
	}
	
	public void setSampleName(String name) {
		this.sampler.setName(name);
	}

}
