package br.ufpr.inf.rp09.testresults;

import java.util.List;

/**
 * Classe responsavel por calcular as variaveis de desempenho
 * a partir dos resultados dos testes
 * 
 * @author Rodrigo Piassetta / GRR20094994
 *
 */
public class PerformanceInputsCalculator {

	public static double calculatePerformanceVariation(int iteration, List<Double> listTransactionsTreatedAvg) {
		if((iteration - 1) == 0)
			return 0.0;
		
		double micro = 0.0;
		for(double d : listTransactionsTreatedAvg) {
			micro += d;
		}
		micro = micro / iteration;
		
		double sum = 0.0;
		for(int i = 0; i < listTransactionsTreatedAvg.size(); i++) {
			double x = listTransactionsTreatedAvg.get(i) - micro;
			sum += Math.pow(x, 2);
		}
		
		double delta = Math.sqrt(sum / (iteration - 1));

		return delta;
	}

	public static double calculateTransactionTroughput(double transactionsTreatedAvg, double transactionsRequestedAvg) {
		if(transactionsRequestedAvg == 0)
			return 0.0;
		
		return transactionsTreatedAvg / transactionsRequestedAvg;
	}

	public static double calculatePerformanceTrend() {
		// TODO fix futuro
		return 0.0;
	}

}
