package br.ufpr.inf.rp09.testresults;

import java.util.ArrayList;
import java.util.List;
import br.ufpr.inf.rp09.statemachine.enumerations.ModastStateEnum;

/**
 * Classe responsavel por agrupar os resultados de cada iteracao de teste
 * 
 * @author Rodrigo Piassetta / GRR20094994
 *
 */
public class TestResultAggregator {

	private List<Long> listTestStartTime; //lista com o timestamp do inicio das iteracoes do teste (indexados pela iteracao - 0-based)
	private List<Long> listTestEndTime; //lista com o timestamp do encerramento das iteracoes do teste (indexados pela iteracao - 0-based)
	private List<ModastStateEnum> listTestState; //lista com o estado do BD em cada iteracao do teste (indexados pela iteracao - 0-based)
	private List<Long> listTransactionsRequestedTotal; //transacoes requisitadas em cada iteracao do teste (indexados pela iteracao - 0-based)
	private List<Long> listTransactionsTreatedTotal; //transacoes tratadas em cada iteracao do teste (indexados pela iteracao - 0-based)
	private List<Double> listTransactionsRequestedRate; //transacoes requisitadas por segundo em cada iteracao do teste (indexados pela iteracao - 0-based)
	private List<Double> listTransactionsTreatedRate; //transacoes tratadas por segundo em cada iteracao do teste (indexados pela iteracao - 0-based)
	private List<Double> listPerformanceVariation; //variacao de desempenho em cada iteracao do teste (indexados pela iteracao - 0-based)
	private List<Double> listTransactionsThroughput; //rendimento de transacoes em cada iteracao do teste (indexados pela iteracao - 0-based)
	private List<Double> listPerformanceTrend; //tendencia de desempenho em cada iteracao do teste (indexados pela iteracao - 0-based)

	public TestResultAggregator() {
		this.listTestStartTime = new ArrayList<Long>();
		this.listTestEndTime = new ArrayList<Long>();
		this.listTestState = new ArrayList<ModastStateEnum>();
		this.listTransactionsRequestedTotal = new ArrayList<Long>();
		this.listTransactionsTreatedTotal = new ArrayList<Long>();
		this.listTransactionsRequestedRate = new ArrayList<Double>();
		this.listTransactionsTreatedRate = new ArrayList<Double>();
		this.listPerformanceVariation = new ArrayList<Double>();
		this.listTransactionsThroughput = new ArrayList<Double>();
		this.listPerformanceTrend = new ArrayList<Double>();
	}
	
	public void setTestStartTime(int index, long startTime) {
		this.listTestStartTime.add(index, startTime);
	}
	
	public long getTestStartTime(int index) {
		return this.listTestStartTime.get(index);
	}
	
	public List<Long> getAllTestStartTime() {
		return this.listTestStartTime;
	}
	
	public void setTestEndTime(int index, long endTime) {
		this.listTestEndTime.add(index, endTime);
	}
	
	public long getTestEndTime(int index) {
		return this.listTestEndTime.get(index);
	}
	
	public List<Long> getAllTestEndTime() {
		return this.listTestEndTime;
	}
	
	public void setTestState(int index, ModastStateEnum state) {
		this.listTestState.add(index, state);
	}
	
	public ModastStateEnum getTestState(int index) {
		return this.listTestState.get(index);
	}
	
	public List<ModastStateEnum> getAllTestState() {
		return this.listTestState;
	}
	
	public void setTransactionsRequested(int index, long transactionsRequested) {
		this.listTransactionsRequestedTotal.add(index, transactionsRequested);
	}
	
	public long getTransactionsRequested(int index) {
		return this.listTransactionsRequestedTotal.get(index);
	}
	
	public List<Long> getAllTransactionsRequested() {
		return this.listTransactionsRequestedTotal;
	}
	
	public void setTransactionsTreated(int index, long transactionsTreated) {
		this.listTransactionsTreatedTotal.add(index, transactionsTreated);
	}
	
	public long getTransactionsTreated(int index) {
		return this.listTransactionsTreatedTotal.get(index);
	}
	
	public List<Long> getAllTransactionsTreated() {
		return this.listTransactionsTreatedTotal;
	}
	
	public void setTransactionsRequestedRate(int index, double transactionsRequestedRate) {
		this.listTransactionsRequestedRate.add(index, transactionsRequestedRate);
	}
	
	public double getTransactionsRequestedRate(int index) {
		return this.listTransactionsRequestedRate.get(index);
	}
	
	public List<Double> getAllTransactionsRequestedRate() {
		return this.listTransactionsRequestedRate;
	}
	
	public void setTransactionsTreatedRate(int index, double transactionsTreatedRate) {
		this.listTransactionsTreatedRate.add(index, transactionsTreatedRate);
	}
	
	public double getTransactionsTreatedRate(int index) {
		return this.listTransactionsTreatedRate.get(index);
	}
	
	public List<Double> getAllTransactionsTreatedRate() {
		return this.listTransactionsTreatedRate;
	}
	
	public void setPerformanceVariation(int index, double performanceVariation) {
		this.listPerformanceVariation.add(index, performanceVariation);
	}
	
	public double getPerformanceVariation(int index) {
		return this.listPerformanceVariation.get(index);
	}
	
	public List<Double> getAllPerformanceVariation() {
		return this.listPerformanceVariation;
	}
	
	public void setTransactionsThroughput(int index, double transactionsTroughput) {
		this.listTransactionsThroughput.add(index, transactionsTroughput);
	}
	
	public double getTransactionsThroughput(int index) {
		return this.listTransactionsThroughput.get(index);
	}
	
	public List<Double> getAllTransactionsThroughput() {
		return this.listTransactionsThroughput;
	}
	
	public void setPerformanceTrend(int index, double performanceTrend) {
		this.listPerformanceTrend.add(index, performanceTrend);
	}
	
	public double getPerformanceTrend(int index) {
		return this.listPerformanceTrend.get(index);
	}
	
	public List<Double> getAllPerformanceTrend() {
		return this.listPerformanceTrend;
	}	
}
