package br.ufpr.inf.rp09.testresults;

import org.apache.jmeter.reporters.ResultCollector;
import org.apache.jmeter.reporters.Summariser;
import org.apache.jmeter.samplers.SampleEvent;
import org.apache.jmeter.samplers.SampleResult;

public class TestResultCollector extends ResultCollector {

	private static final long serialVersionUID = 292134780163055333L;
	private long startTime;
	private long endTime;
	private long totalTransactionsRequests;
	private long totalTransactionsTreated;
	private long totalError;


	public TestResultCollector() {
		super();
		
		this.startTime = 0L;
		this.endTime = 0L;
		this.totalTransactionsRequests = 0L;
		this.totalTransactionsTreated = 0L;
		this.totalError = 0L;
	}

	public TestResultCollector(Summariser summer) {
		super(summer);

		this.startTime = 0L;
		this.endTime = 0L;
		this.totalTransactionsRequests = 0L;
		this.totalTransactionsTreated = 0L;
		this.totalError = 0L;
	}

	@Override
	public void sampleOccurred(SampleEvent ev) {
		super.sampleOccurred(ev);

		SampleResult res = ev.getResult();
		
		setStartTime(res.getStartTime());
		setEndTime(res.getEndTime());
		this.totalTransactionsRequests++;
		this.totalError += res.getErrorCount();
		if(res.isSuccessful())
			this.totalTransactionsTreated++;
	}	
	

	private void setStartTime(long startTime) {
		if(this.startTime == 0 || startTime < this.startTime)
			this.startTime = startTime;		
	}
	
	public long getStartTime() {
		return this.startTime;
	}
	
	private void setEndTime(long endTime) {
		if(endTime > this.endTime)
			this.endTime = endTime;		
	}
	
	public long getEndTime() {
		return this.endTime;
	}

	public long getElapsedTime() {
		return this.endTime - this.startTime;
	}
	
	public long getTotalTransactionsRequests() {
		return this.totalTransactionsRequests;
	}

	public long getTotalTransactionsTreated() {
		return this.totalTransactionsTreated;
	}

	public long getTotalError() {
		return this.totalError;
	}	
}
