package br.ufpr.inf.rp09.testresults;

/**
 * Implementa metodos qua auxiliam a conversao e calculo dos resultados dos testes
 * 
 * @author Rodrigo Piassetta / GRR20094994
 *
 */
public class TestResultsCalculator {

	/**
	 * Converte um valor em milissegundos para segundos
	 * 
	 * @param timeInMillis valor em milissegundos
	 * @return o valor em segundos
	 */
	public static double convertElapsedTimeMillis2Seconds(long timeInMillis) {
		return (1.0*timeInMillis)/1000;
	}

	/**
	 * Calcula a frequencia por segundo de um valor total de amostras 
	 *  
	 * @param total o valor total de amostras 
	 * @param timeInSeconds periodo em segundos em que ocorreram as amostras
	 * 
	 * @return o numero de amostrar ocorridas por segundo
	 */
	public static double calculateRatePerSecond(long total, double timeInSeconds) {
		if(timeInSeconds <= 0)
			return 0.0;
		
		if(timeInSeconds <= 1)
			return 1.0*total;
		
		return (1.0*total)/timeInSeconds;
	}

}
